/*
BlindBonus

Player will gain some money for kill enemy, when is flashbanged.
*/
#include <amxmodx>
#include <cstrike>
#include <colors>

#define VERSION "1.0"

new bool:gbIsBlind[33];

new gcvarBlindBonus, gcvarMessColor;
new gcvarMessPosX, gcvarMessPosY;

new gColor[3], Float:gPosX, Float:gPosY;
public plugin_init() {
	register_plugin("BlindBonus", VERSION, "R3X");
	register_dictionary("blind_bonus.txt");
	colors_init();
	
	register_event("ScreenFade", "eventFlashed", "be", "4=255", "5=255", "6=255", "7>199");
	register_event("ResetHUD", "eventResetHud", "be");
	register_event("DeathMsg", "eventDeathMsg", "a");
	register_logevent( "getValues",2, "1=Round_End");
	
	
	gcvarBlindBonus=register_cvar("amx_blind_bonus", "100");
	gcvarMessColor=register_cvar("amx_blind_mess_color", "orange");
	gcvarMessPosX=register_cvar("amx_blind_mess_posx", "0.01", 0, 0.01);
	gcvarMessPosY=register_cvar("amx_blind_mess_posy", "0.82", 0, 0.82);
}
public eventFlashed(id){
	gbIsBlind[id]=true;
	new Float:fHold = float(read_data(2))/ (1<<11); //twice longer than holdtime
	set_task(fHold, "noLongerFlashed",id);
	return PLUGIN_CONTINUE;
}
public eventResetHud(id)
	if(task_exists(id)){
		gbIsBlind[id]=false;
		remove_task(id);
	}
public noLongerFlashed(id)
	gbIsBlind[id]=false;
public eventDeathMsg(){
	new idKiller=read_data(1);
	if(!is_user_connected(idKiller)) 
		return PLUGIN_CONTINUE;
	new idVictim=read_data(2);
	if(cs_get_user_team(idKiller)!=cs_get_user_team(idVictim)&& 
	 gbIsBlind[idVictim] ){
	 	new iBonus=get_pcvar_num(gcvarBlindBonus);
		if(!iBonus) 
			return PLUGIN_CONTINUE;
		cs_set_user_money(idKiller, cs_get_user_money(idKiller)+iBonus);
		
		set_hudmessage(gColor[0], gColor[1], gColor[2], gPosX, gPosY, 0, 6.0, 3.0, 0.1, 1.0);
		show_hudmessage(idKiller, "%L",idKiller, "BONUS_MESSAGE",iBonus);
	}
	return PLUGIN_CONTINUE;
}

//------------------------------
//Once per round check values
//------------------------------
public plugin_cfg()
	getValues();
public getValues(){
	gPosX=get_pcvar_float(gcvarMessPosX);
	gPosY=get_pcvar_float(gcvarMessPosY);
	new szColor[COLORS_NAME_LEN];
	get_pcvar_string(gcvarMessColor, szColor, COLORS_NAME_LEN-1);
	if(!get_full_color(szColor, gColor)){
		log_amx("%L", LANG_SERVER, "BAD_COLOR");
		gColor[0]=255;
		gColor[1]=255;
		gColor[2]=255;
	}
}